using System;
using System.IO;
using System.Text;
using System.Collections;
using System.Diagnostics;
using System.Runtime.InteropServices;
using WordA = Microsoft.Office.Interop.Word;

using Keyoti.SearchEngine;
using Keyoti.SearchEngine.Documents;
using Keyoti.SearchEngine.DataAccess;


namespace NewWordParser
{
	public class CustomParser:Parser
	{		
		private WordA.Application vk_word_app;

		public CustomParser(string temporaryFilePath){this.tempFNAME = temporaryFilePath;}



		string tempFNAME;

		void CopyStreamToTempFile(Stream stream)
		{
			BinaryReader br = new BinaryReader(stream);
			BinaryWriter bw = new BinaryWriter(new FileStream(tempFNAME, FileMode.Create));
			byte[] inbytes = new byte[1024];
			int read;
			while( (read = br.Read(inbytes, 0, inbytes.Length)) > 0)
			{
				bw.Write(inbytes, 0, read);
			}
			br.Close();
			bw.Close();
		}

		public override object[] ReadText(Stream stream, Uri uri)
		{
		
			if(File.Exists(tempFNAME))
				File.Delete(tempFNAME);

			CopyStreamToTempFile(stream);
        
			string content = ReadTempDoc();
			TxtDocumentParser parser = new TxtDocumentParser();
			return parser.ReadText(content, uri);
		}




		//uses Office PIAs to open and read Word doc.
		string ReadTempDoc()
		{
			string text = "";


			vk_word_app = new Microsoft.Office.Interop.Word.Application();

			
			object  fileName = tempFNAME;

			object  vk_read_only  = true;
			object  vk_visible  = true;
			object  vk_false    = false;
			object  vk_true    = true;
			object  vk_dynamic  = 2;
    
			object  vk_missing  = System.Reflection.Missing.Value;

			


			// Let's open the document
			try
			{

				vk_word_app.Visible = false;
				if(vk_word_app.Visible) vk_word_app.Activate();

				//Office XP
				/*
				Microsoft.Office.Interop.Word.Document vk_my_doc = vk_word_app.Documents.Open(
					ref fileName, ref vk_false, ref vk_read_only,
					ref vk_missing, ref vk_missing, ref vk_missing, ref vk_missing, ref vk_missing, ref vk_missing, ref vk_missing,ref vk_missing,
					ref vk_visible, ref vk_false, ref vk_missing, ref vk_true);
				*/
				//Office 2003
				
				Microsoft.Office.Interop.Word.Document vk_my_doc = vk_word_app.Documents.Open(ref fileName, ref vk_false, ref vk_read_only,
					ref vk_missing, ref vk_missing, ref vk_missing, ref vk_missing, ref vk_missing, ref vk_missing, ref vk_missing,ref vk_missing,
					ref vk_visible, ref vk_false, ref vk_missing, ref vk_true, ref vk_missing);
				
				//-------------------------------------------------------------------------------



				vk_my_doc.Activate();

				vk_word_app.ActiveDocument.Select();
				text = vk_word_app.Selection.Text;

			} 
			catch (Exception e)
			{
				
				System.Windows.Forms.MessageBox.Show("Word Doc parser failed: "+e.Message+" "+e.StackTrace);
			} 
			finally 
			{
				object missing = Type.Missing;
				vk_false    = false; vk_true = true;
				vk_word_app.Quit(ref vk_false, ref missing, ref missing);
				vk_word_app = null;
				GC.Collect();
				GC.WaitForPendingFinalizers();
				GC.Collect();
				GC.WaitForPendingFinalizers();
			}


			return text;
	
		}

		public override object[] ReadText(Stream stream, Uri uri, Encoding encoding)
		{
			this.encoding = encoding;
			return this.ReadText( stream, uri );
		}

		public override ArrayList ReadLinks(Stream stream)
		{
			return ReadLinks(stream, Encoding.Default);
		}

		public override ArrayList ReadLinks(Stream stream, Encoding encoding)
		{
			//Cant read document links in this format
			return new ArrayList();
		}

			

	}


}
